06/28/2016 06:16 PM - Greg Koch

Status: New   

Priority: Normal   

Assignee:    

Category:    

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

When the Foreman server is down/unreachable the node.rb ENC script will return 1 with an error message of

Error retrieving node da1haln01pe.stsky.biz: Net::HTTPServiceUnavailable

Check Foreman's /var/log/foreman/production.log for more information.

 Adding "RuntimeError" to the list of rescues on line 347 fixes the issue.

rescue TimeoutError, SocketError, Errno::EHOSTUNREACH, Errno::ECONNREFUSED, RuntimeError

 This is the version of node.rb I am using: https://github.com/theforeman/puppet-foreman/blob/master/files/external_node_v2.rb

History

#1 - 06/28/2016 06:20 PM - Greg Sutcliffe

I was helping to debug this on IRC - it seems that

the Apache server is still up but serving Service Unavailable, so we're not hitting the timeout

line 199 is consuming the real error code and raising RuntimeError instead

We should probably rewrite line 199 to pass the real error type up the stack and then add Net::HTTPServiceUnavailable to the list of rescues on line

347

#2 - 07/01/2016 08:03 AM - Daniel Lobato Garcia

- Pull request https://github.com/theforeman/puppet-foreman/pull/460 added

#3 - 07/07/2016 10:12 AM - Greg Koch

I applied this PR to our puppet masters.  At this point we have apache up but requests to it are timing out and node.rb now returns 

 Could not send facts to Foreman: Net::ReadTimeout

instead of using the cache.

#4 - 07/07/2016 11:13 AM - Greg Koch

And when Apache is stopped, we receive the following, again ignoring the cache:

Error retrieving node node.example.com: Net::HTTPServiceUnavailableCheck Foreman's /var/log/foreman/production

.log for more information.

#5 - 07/08/2016 06:44 AM - Daniel Lobato Garcia

I can make it capture that Timeout error easily, I think we should rescue Timeout::Error instead, which is the parent exception of TimeoutError and

ReadTimeout (and other timeouts).

The second error is kind of confusing though, as `res.code` should be 503 for Net::HTTPServiceUnavailable, which we should capture and raise here 
https://github.com/theforeman/puppet-foreman/blob/master/files/external_node_v2.rb


https://github.com/theforeman/puppet-foreman/pull/460/files#diff-56980159eb7873d008e28343dd19c1f3R201

#6 - 12/21/2016 11:04 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Daniel Lobato Garcia

#7 - 05/20/2017 10:34 AM - Anonymous

- Status changed from Ready For Testing to New

- Assignee deleted (Daniel Lobato Garcia)

#8 - 05/20/2017 10:34 AM - Anonymous

- Pull request deleted (https://github.com/theforeman/puppet-foreman/pull/460)
